

## Endpoint Schemas

### '/v2/mobile-tencent/ping' ping
```javascript
```
### '/v2/m/tc/tokens' updateMidasTokens
```javascript
@validate.body({
  openid: String,
  openkey: String,
  payToken: String,
  pf: String,
  pfkey: String
})
```
### '/v2/m/tc/products' getQualify
```javascript
```
### '/v2/m/tc/guest/token' verifyGuestToken
```javascript
@sanitize.body({
  'pf!': 'qq_m_qq-nnnn-android-xxxx',
  tokenType: sanitize.String({ def: 'jwt' })
})
@validate.body({
  guestid: String,
  guestkey: String,
  pf: String,
  'tokenType?': validate.String({ eq: ['jwt', 'binary-jwt'] })
})
@validate.result({
  access_token: String,
  token_type: String,
  refresh_token: String
})
```
### '/v2/m/tc/guest/bind' bindGuest
```javascript
// here comes new comment
@sanitize.body({
  'pf!': 'qq_m_qq-nnnn-android-xxxx',
  tokenType: sanitize.String({ def: 'jwt' })
})
@validate.body({
  openid: String,
  openkey: String,
  guestid: String,
  guestkey: String
})
@validate.result({
  result: Boolean
})
```

