# island-doc

parse island environment.ts, constant.ts 
and update README.md '## Environment Variables' section

## Environment Variables

| Name | Type | Default | Notes | LegacyKeys |
| - | - | - | - | - |
| ISLAND_SERVICE_NAME | String | 'no-service-name' |   | 't' |
| ISLAND_HOST_NAME | String | 'no-host-name' | // TraceLog uses this as a name of node |   |
| ISLAND_USE_DEV_MODE | Boolean | false | // When true, allows APIs which has options.developmentOnly |   |
| ISLAND_SERIALIZE_FORMAT_PUSH | String | 'msgpack' | // currently able Push format json and msgpack |   |
| ISLAND_SERVICE_LOAD_TIME_MS | Number | 60000 |   |   |
| ISLAND_LOGGER_LEVEL | String | 'info' | // Log level for logger |   |
| ISLAND_LOGGER_TYPE | String | 'short' |   |   |
| ISLAND_RPC_RES_NOACK | Boolean | false |   |   |


## Error Codes

```javascript
E0001_SESSION_ALREADY_SET = 1
E0002_MISSING_SID = 2
E0003_MISSING_AID = 3
E0005_DUPLICATED_LOGIN = 5
E0006_SESSION_UPDATE_FAILED = 6
E0007_SESSION_NOT_EXIST = 7
E0008_SESSION_GROUP_NAME_IS_RESERVED = 8
E0009_SESSION_LOCKED = 9
E0010_SESSION_CLEAR_FAILED = 10
E0011_INVALID_ARGS = 11
```



## Mongoose Schemas

### localUserSchema
```javascript
{
      aid: { type: mongoose.Schema.Types.ObjectId, required: true },
      name: { type: String, required: true, unique: true }
    }
{shardKey: {name: 'hashed'}} as any
```
### testSchema
```javascript
{
      aid: { type: mongoose.Schema.Types.ObjectId, required: true },
      name: { type: String, required: true, unique: true }
    }
```

