"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
// tslint:disable-next-line
require('source-map-support').install();
// https://github.com/Microsoft/TypeScript/wiki/Using-the-Compiler-API
// https://github.com/basarat/typescript-book/blob/master/docs/compiler/ast-trivia.md
// https://github.com/Microsoft/TypeScript/blob/master/src/compiler/types.ts
// See typescript.d.ts
var ts = require("typescript");
var fs = require("fs");
var glob = require("glob");
var mdExporter = require("./util/md.exporter");
var confluence_uploader_1 = require("./util/confluence.uploader");
var island_base_service_1 = require("./service/island.base.service");
var common_island_service_1 = require("./service/common.island.service");
var islandDoc = /** @class */ (function () {
    function islandDoc() {
        this.options = {
            mdFilePath: './README.md',
            mdFilesuffix: '',
            sourceFilePath: './src/',
            sourceFilePattern: '+(*controller|environments|constant|error|*model).ts',
            globOptions: {
                ignore: ["**/node_modules*/**", "./node_modules/**"]
            }
        };
    }
    islandDoc.prototype.getProgram = function (path, pattern, includeNodeModules) {
        if (pattern === void 0) { pattern = this.options.sourceFilePattern; }
        if (includeNodeModules === void 0) { includeNodeModules = false; }
        if (!fs.existsSync(path))
            return null;
        var files = glob.sync(path + "/**/" + pattern, { ignore: includeNodeModules ? [] : ["**/node_modules/**", "./node_modules/**"] });
        if (files.length < 1)
            return null;
        var tsconfig = JSON.parse(fs.readFileSync('./tsconfig.json').toString('utf-8'));
        var compilerOptions = ts.convertCompilerOptionsFromJson(tsconfig.compilerOptions, '.');
        var program = ts.createProgram(files, compilerOptions.options);
        // const checker: ts.TypeChecker = program.getTypeChecker();
        return program;
    };
    islandDoc.prototype.run = function (callback, options) {
        return __awaiter(this, void 0, void 0, function () {
            var testMode, ibsProgram, ibs, program, cis, cu, envText, mongooseText, islandCodes, errorEnums, errorText, readMeContent, saveFileName, eventText, eventContent, saveFileName, endpointText, endpointContent, saveFileName, rpcText, rpcContent, saveFileName, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, 4, 5]);
                        testMode = options && options.test;
                        if (testMode) {
                            this.options.mdFilePath = './spec/*.md';
                            this.options.mdFilesuffix = '.md';
                            this.options.sourceFilePath = './spec/';
                            this.options.sourceFilePattern = "sample*.ts";
                        }
                        ibsProgram = this.getProgram('./node_modules/island-base/src/', '*.ts', true);
                        ibs = new island_base_service_1.IslandBaseService(ibsProgram);
                        program = this.getProgram(this.options.sourceFilePath, this.options.sourceFilePattern);
                        cis = new common_island_service_1.CommonIslandService(program, ibs);
                        cu = new confluence_uploader_1.ConfluenceUploader();
                        envText = mdExporter.createTableFromMdText(cis.envDecorators);
                        mongooseText = mdExporter.createMdText(cis.mongooseSchemas);
                        islandCodes = ibs.getValue('IslandCode');
                        errorEnums = cis.errorEnums;
                        errorText = mdExporter.createMdText(islandCodes.concat(errorEnums));
                        if (!(envText || mongooseText || errorText)) return [3 /*break*/, 2];
                        readMeContent = fs.existsSync('./README.md') ? fs.readFileSync('./README.md', 'utf8') : '';
                        readMeContent = mdExporter.replaceSection(readMeContent, 'Error Codes', errorText);
                        readMeContent = mdExporter.replaceSection(readMeContent, 'Environment Variables', envText);
                        readMeContent = mdExporter.replaceSection(readMeContent, 'Mongoose Schemas', mongooseText);
                        saveFileName = "./README.md" + this.options.mdFilesuffix;
                        fs.writeFileSync(saveFileName, readMeContent, 'utf8');
                        if (!(options && options.updateConfluence)) return [3 /*break*/, 2];
                        console.log(1);
                        return [4 /*yield*/, cu.uploadErrorCodes(this.getProjectInfo(), errorEnums, islandCodes)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        eventText = mdExporter.createMdText(cis.events);
                        if (eventText) {
                            eventContent = fs.existsSync('./EVENT.md') ? fs.readFileSync('./EVENT.md', 'utf8') : '';
                            saveFileName = "./EVENT.md" + this.options.mdFilesuffix;
                            fs.writeFileSync(saveFileName, eventContent, 'utf8');
                            eventContent = mdExporter.replaceSection(eventContent, 'Event Schemas', eventText);
                        }
                        endpointText = mdExporter.createMdText(cis.endpoints);
                        if (endpointText) {
                            endpointContent = fs.existsSync('./ENDPOINT.md') ? fs.readFileSync('./ENDPOINT.md', 'utf8') : '';
                            endpointContent = mdExporter.replaceSection(endpointContent, 'Endpoint Schemas', endpointText);
                            saveFileName = "./ENDPOINT.md" + this.options.mdFilesuffix;
                            fs.writeFileSync(saveFileName, endpointContent, 'utf8');
                        }
                        rpcText = mdExporter.createMdText(cis.rpcs);
                        if (rpcText) {
                            rpcContent = fs.existsSync('./RPC.md') ? fs.readFileSync('./RPC.md', 'utf8') : '';
                            rpcContent = mdExporter.replaceSection(rpcContent, 'RPC Schemas', rpcText);
                            saveFileName = "./RPC.md" + this.options.mdFilesuffix;
                            fs.writeFileSync(saveFileName, rpcContent, 'utf8');
                        }
                        return [3 /*break*/, 5];
                    case 3:
                        err_1 = _a.sent();
                        console.error(err_1);
                        return [3 /*break*/, 5];
                    case 4: return [2 /*return*/, typeof callback === 'function' ? callback() : undefined];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    islandDoc.prototype.getProjectInfo = function () {
        try {
            var pkgJson = require(process.cwd() + "/package.json");
            return {
                name: pkgJson.name,
                version: pkgJson.version
            };
        }
        catch (e) {
            return {};
        }
    };
    return islandDoc;
}());
var islandDocMaker = new islandDoc();
exports["default"] = islandDocMaker;
