"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var _ = require("lodash");
var confluency_1 = require("confluency");
// https://developer.atlassian.com/server/confluence/confluence-rest-api-examples/
var ConfluenceUploader = /** @class */ (function () {
    function ConfluenceUploader() {
        // gitToken: string = 'pzNr-px6qbPma3FXESSV';
        this.confluency = new confluency_1["default"]({
            host: 'http://krconfluence.ea.com:8090',
            context: '',
            username: 'eass-build',
            password: 'Welcome2ea!!'
        });
        // async makeReference(projectInfo: any) {
        //   const { name, id, http_url_to_repo } = projectInfo;
        //   const reference: any = {};
        //   await this.gitClone(http_url_to_repo);
        //   const branches = (await this.getBranches(id)).map(info => info['name']);
        //   if (branches.length < 1) return;
        //   for (const branch of branches) {
        //     reference[branch] = {};
        //     console.log(`${name} - ${branch}`);
        //     await this.gitCheckout(name, branch);
        //     await this.getDecorator(`${this.sourcePath}/${name}/src/controller`, reference[branch]);
        //   }
        //   const projectPageId: number = await this.createPage(this.confluence.ancestors, `[Reference] ${name}`, '');
        //   for (const branch in reference) {
        //     if (!Object.keys(reference[branch])) continue;
        //     const referenceBody = [];
        //     referenceBody.push('<ac:structured-macro ac:name="toc" ac:schema-version="1" ac:macro-id="92e1ce42-8f5d-4ec5-a87a-cc567471a516" />');
        //     for (const methodType in reference[branch]) {
        //       referenceBody.push(`<h1>${methodType}</h1>`);
        //       for (const methodName in reference[branch][methodType]) {
        //         referenceBody.push(`<h2>${methodName}</h2>`);
        //         if (!reference[branch][methodType][methodName].decorators || reference[branch][methodType][methodName].decorators.length < 1) continue;
        //         reference[branch][methodType][methodName].decorators.sort();
        //         referenceBody.push(...reference[branch][methodType][methodName].decorators);
        //       }
        //     }
        //     await this.createPage(projectPageId, `[Reference] ${name} > ${branch}`, `<p>${referenceBody.join('</p><p>').replace(/\n/g, "")}</p>`);
        //   }
        // }
        // async run() {
        //   const gitGroupCode: number = 75;
        //   await this.initDir();
        //   const projects = await this.getProjects(gitGroupCode);
        //   //projects.map(project => this.removeAllPages(project));
        //   projects.map(project => this.makeReference(project));
        // }
    }
    ConfluenceUploader.prototype.getNextVersion = function (page) {
        if (!page || !page.version || !page.version.number)
            return 2;
        return page.version.number + 1;
    };
    ConfluenceUploader.prototype.getIslandCode = function (projectName, islandCodes) {
        if (!islandCodes)
            return '';
        var matched = JSON.stringify(islandCodes).match(new RegExp("[^A-z]" + projectName + "[\\s=]+([0-9]+)"));
        if (!matched)
            return '';
        return matched[1];
    };
    ConfluenceUploader.prototype.errorCodeToHtml = function (projectInfo, errorCodes, islandCodes) {
        var projectName = projectInfo.name.toUpperCase().replace('-ISLAND', '').replace('-', '_');
        var islandCode = this.getIslandCode(projectName, islandCodes);
        var referenceBody = [];
        // enum IslandCode
        // enum ERROR
        referenceBody.push(projectInfo.name + "-" + projectInfo.version);
        referenceBody.push('<div class="table-wrap"><table class="confluenceTable">');
        referenceBody.push('<colgroup><col/><col/><col/><col/><col/></colgroup><tbody>');
        _.forEach(errorCodes, function (code) {
            var matched = code.match(/([A-z0-9]+)[\s=]+([0-9]+)/);
            if (matched) {
                referenceBody.push("<tr>\n        <td class=\"confluenceTd\">" + islandCode + matched[2].padStart(5, '0') + "</td>\n        <td class=\"confluenceTd\">" + projectInfo.name + "</td>\n        <td class=\"confluenceTd\">" + matched[1] + "</td>\n        <td class=\"confluenceTd\">" + islandCode + "</td>\n        <td class=\"confluenceTd\">" + matched[2] + "</td>\n        </tr>");
            }
        });
        referenceBody.push('</tbody></table></div>');
        // <div class="table-wrap"><table class="confluenceTable">
        // <colgroup><col/><col/></colgroup>
        // <tbody>
        // <tr><td class="confluenceTd">E0001_TEMP</td><td class="confluenceTd">1</td>
        // </tbody></table></div>
        //     referenceBody.push('<ac:structured-macro ac:name="toc" ac:schema-version="1" ac:macro-id="92e1ce42-8f5d-4ec5-a87a-cc567471a516" />');
        //     for (const methodType in reference[branch]) {
        //       referenceBody.push(`<h1>${methodType}</h1>`);
        //       for (const methodName in reference[branch][methodType]) {
        //         referenceBody.push(`<h2>${methodName}</h2>`);
        //         if (!reference[branch][methodType][methodName].decorators || reference[branch][methodType][methodName].decorators.length < 1) continue;
        //         reference[branch][methodType][methodName].decorators.sort();
        //         referenceBody.push(...reference[branch][methodType][methodName].decorators);
        //       }
        //     }
        // console.log(referenceBody);
        return referenceBody.join('');
    };
    ConfluenceUploader.prototype.uploadErrorCodes = function (projectInfo, errorCodes, islandCodes) {
        return __awaiter(this, void 0, void 0, function () {
            var parentSpace, parentPageId, title, pages, targetPage;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        parentSpace = 'ACT';
                        parentPageId = 66766730;
                        title = projectInfo.name + "-" + projectInfo.version;
                        return [4 /*yield*/, this.confluency.getChildren(parentPageId, { all: true, expand: ['version'] })];
                    case 1:
                        pages = _a.sent();
                        targetPage = _.find(pages, function (p) { return p.title === title; });
                        try {
                            if (targetPage) {
                                this.confluency.update({
                                    space: parentSpace,
                                    id: targetPage.id,
                                    version: this.getNextVersion(targetPage),
                                    title: title,
                                    content: this.errorCodeToHtml(projectInfo, errorCodes, islandCodes),
                                    parent: parentPageId
                                });
                            }
                            else {
                                this.confluency.create({
                                    space: parentSpace,
                                    title: title,
                                    content: this.errorCodeToHtml(projectInfo, errorCodes, islandCodes),
                                    parent: parentPageId
                                });
                            }
                            console.log("[Confluence Updated] " + title);
                        }
                        catch (err) {
                            console.error("[Confluence Update Error] " + err);
                        }
                        // console.log(data);
                        return [2 /*return*/];
                }
            });
        });
    };
    return ConfluenceUploader;
}());
exports.ConfluenceUploader = ConfluenceUploader;
